#include "stdafx.h"
#include "resource.h"
#include <aygshell.h>						// vibrate.hG[ɂȂ̂ō폜
#include <commctrl.h>
#include <windowsx.h>
#include <commdlg.h>


// Pixie.cpp
extern BOOL DoSetClipboard(HWND hWnd, TCHAR szStr[]);
extern BOOL GetOpenFileNameEx(OPENFILENAME* pofn);
extern INT DoGetFileName(HWND hWnd, LPTSTR szFileName, INT nMax, LPTSTR szOpenFilter);

extern HWND				hWndMain;
extern HWND				hWndEdit;

const int				ITEMLIST_MAX = 64;
static TCHAR			szItemList[128][ITEMLIST_MAX] = {
	_T("()"),
	_T("[]"),
	_T("{}"),
	_T("()"),
	_T("()"),
	_T("()"),
	_T("\\n"),
	_T("\\W"),
	_T("\\U"),
	_T("\\D"),
	_T("\\L"),
	_T("\\R"),
	_T("ɂ"),
	_T("܂"),
	_T("(^^)"),
	_T("(^^;"),
	_T("( --)/(;'')"),
	_T("(^_^ )"),
	_T("(*^^)l(*^-^*)l(^^*)"),
	NULL,
};


struct DLGITEM_T {
	int id;
	int left;
	int top;
	int right;
	int bottom;
};
static int iDlgItemId[] = {
	IDC_LIST_BRACKETS,
	IDCANCEL,
	IDOK,
	IDC_BTN_OPEN,
	-1
};


// Xgւ̕ݒ
int SetListText(HWND hWnd)
{
	int n;

	SendDlgItemMessage(hWnd, IDC_LIST_BRACKETS, WM_SETREDRAW, FALSE, 0L);
	SendDlgItemMessage(hWnd, IDC_LIST_BRACKETS, LB_RESETCONTENT, 0, 0L);
	for (n=0; szItemList[n][0]; n++) {
		SendDlgItemMessage(hWnd, IDC_LIST_BRACKETS, LB_ADDSTRING, 0, (LPARAM)(LPSTR)szItemList[n]);
	}
	SendDlgItemMessage(hWnd, IDC_LIST_BRACKETS, WM_SETREDRAW, TRUE, 0L);
	return 0;
}

// ̋L
int SetBufferText(LPTSTR pBuff)
{
	int n;
	LPTSTR p;

	n = 0;
	for (p = wcstok(pBuff, _T("\r\n")); p != NULL; p = wcstok(NULL, _T("\r\n"))) {
		if (wcslen(p) >= sizeof(szItemList[n])) continue;
		lstrcpy(szItemList[n], p);
		n++;
		if (n >= ITEMLIST_MAX-1) break;
	}
	szItemList[n][0] = 0;
	return 0;
}

// t@Cǂݍ
BOOL ReadFileFreeWord(HWND hWnd, LPTSTR szFileName)
{
	HANDLE hFile;
	DWORD nFileSizeMb;
	DWORD nCnt;										// ǂݏof[^
	BOOL res = TRUE;
	//TCHAR szStr[128];
	LPSTR pWorkMb;
	LPTSTR pBuffWc;
	UINT nLenWc;
	HICON hiconIcon;

	hFile = CreateFile(szFileName, GENERIC_READ | GENERIC_WRITE,
						FILE_SHARE_READ, NULL, OPEN_EXISTING, 
						FILE_ATTRIBUTE_NORMAL, NULL);
	if (hFile == INVALID_HANDLE_VALUE) {
		//wsprintf(szStr, TEXT("%s ܂."), szFileName);
		//MessageBox(hWnd, szStr, TEXT("error"), MB_OK);
		return FALSE;
	}
	nFileSizeMb = GetFileSize(hFile, NULL);				// t@CTCY擾
	pWorkMb = (LPSTR)LocalAlloc(LPTR, nFileSizeMb+1);	// Ǐom
	if (pWorkMb == NULL) {								// mۂłȂ΃G[
		MessageBox(hWnd, TEXT("mۂł܂ł(1)"), TEXT("error"), MB_OK);
		return FALSE;
	}

	hiconIcon = LoadCursor(NULL, IDC_WAIT);
	SetCursor(hiconIcon);

	ReadFile(hFile, pWorkMb, nFileSizeMb, &nCnt, NULL);
	CloseHandle(hFile);

	//wsprintf(szStr, TEXT("%d:%d byte"), nFileSize, nCnt);	//
	//MessageBox(hWnd, szStr, TEXT("debug"), MB_OK);			//

	if (nCnt != nFileSizeMb) {								// read NG
		MessageBox(hWnd, TEXT("t@CǍG[."), TEXT("error"), MB_OK);
		res = FALSE;

	} else {												// read OK
		nLenWc = MultiByteToWideChar(CP_ACP, 0, pWorkMb, -1, 0, 0);
		pBuffWc = (LPTSTR)LocalAlloc(LPTR, nLenWc*sizeof(TCHAR));	// UNICODEDϊm
		if (pBuffWc == NULL) {								// mۂłȂ΃G[
			MessageBox(hWnd, TEXT("mۂł܂ł(2)."), TEXT("error"), MB_OK);
			res = FALSE;

		} else {											// mۂł΃R[hϊ
			MultiByteToWideChar(CP_ACP, 0, pWorkMb, -1, pBuffWc, nLenWc);
			SetBufferText(pBuffWc);
//			SetListText(hWnd);
			LocalFree(pBuffWc);
		}
	}

	SetCursor(0);
	LocalFree(pWorkMb);
	return res;
}

// J
void DoOpenFileFreeWord(HWND hWnd)
{
	static TCHAR szFilter[] = 
		TEXT("ׂẴt@C (*.*)\0*.*\0\0");
	TCHAR szFname[MAX_PATH] = TEXT("");

	szFname[0] = 0;
	if (DoGetFileName(hWnd, szFname, MAX_PATH, szFilter)) {
		ReadFileFreeWord(hWnd, szFname);
		SetListText(hWnd);
	}
}

// WM_INITDIALOG
BOOL DoInitDialogBrackets(HWND hDlg)
{
	RECT rt1, rt;
	int Width, Height;
	int i;
	int w, h, x, y;
	HWND hWndItem;

	GetClientRect(hDlg, &rt1);
	Width	= (rt1.right - rt1.left) - 4;
	Height	= (rt1.bottom - rt1.top) - 4;

	for (i=1; iDlgItemId[i] != -1; i++) {
		hWndItem = GetDlgItem(hDlg, iDlgItemId[i]);
		GetClientRect(hWndItem, &rt);
		w = rt.right  - rt.left;
		h = rt.bottom - rt.top;
		x = rt1.right - w*i - 2;
		y = rt1.bottom - h - 2;
		SetWindowPos(hWndItem, 0, x, y, w, h, SWP_NOZORDER | SWP_NOSIZE);
	}

	x = 2;
	y = 2;
	SetWindowPos(GetDlgItem(hDlg, IDC_LIST_BRACKETS), 0, x, y, Width, Height - h - 2, SWP_NOZORDER);

	SetListText(hDlg);

	return TRUE;
}

// I_CAO
LRESULT CALLBACK DlgBrackets(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	SHINITDLGINFO shidi;
	int n;

	switch (message)
	{
		case WM_INITDIALOG:
			shidi.dwMask = SHIDIM_FLAGS;
			shidi.dwFlags = SHIDIF_DONEBUTTON | SHIDIF_SIPDOWN | SHIDIF_SIZEDLGFULLSCREEN;
			shidi.hDlg = hDlg;
			SHInitDialog(&shidi);
			SetForegroundWindow(hDlg);
			DoInitDialogBrackets(hDlg);
			return TRUE; 

		case WM_COMMAND:
			switch ( GET_WM_COMMAND_ID(wParam, lParam) ) {
			case IDC_BTN_OPEN:
				DoOpenFileFreeWord(hDlg);
				ShowWindow(GetDlgItem(hDlg, IDC_LIST_BRACKETS), SW_SHOW);
				ShowWindow(hDlg, SW_SHOW);
				break;
			case IDOK:
				n = (int)SendDlgItemMessage(hDlg, IDC_LIST_BRACKETS, LB_GETCURSEL, 0, 0L);
				if (n >= 0) {
					DoSetClipboard(hDlg, szItemList[n]);
					SendMessage(hWndEdit, WM_PASTE, 0, 0);
				}
				EndDialog(hDlg, LOWORD(wParam));
				return TRUE;

			case IDCANCEL:
				EndDialog(hDlg, LOWORD(wParam));
				return TRUE;
			}
			break;
	}
    return FALSE;
}
