#include "stdafx.h"
#include "resource.h"
#include <aygshell.h>						// vibrate.hG[ɂȂ̂ō폜
#include <commctrl.h>
#include <windowsx.h>

// Pixie.cpp
extern BOOL DoSetClipboard(HWND hWnd, TCHAR szStr[]);

extern HWND				hWndMain;
extern HWND				hWndEdit;

#define WINLIST_MAX		50
static int				iWinlistMax = WINLIST_MAX;
static HWND				hTask[WINLIST_MAX];
static int				nTask =0;

TCHAR					szCaptionname[100][WINLIST_MAX];

struct DLGITEM_T {
	int id;
	int left;
	int top;
	int right;
	int bottom;
};
static int iDlgItemId[] = {
	IDC_LIST1,
	IDCANCEL,
	IDC_BUTTON_BOTH,
	IDC_BUTTON_CLASS,
	IDC_BUTTON_TITLE,
	-1
};


#if 0
// ȊOňԏɂEChE
HWND GetNextTopWindow(void)
{
	HWND	winhWnd = 0;
	TCHAR	szTaskCaption[100];

	winhWnd = hWndMain;
	while (winhWnd = GetWindow(winhWnd, GW_HWNDNEXT)) {
		if (IsWindowVisible(winhWnd)) {
			GetClassName(winhWnd, szTaskCaption, 80);
			if (!GetWindowText(winhWnd, szTaskCaption, 99)) {
				continue;
			}
			if (GetWindow(winhWnd, GW_OWNER) != NULL) {
				continue;
			}
			if (!lstrcmp(szTaskCaption, _T("MS_SIPBUTTON"))) {
				continue;
			}
			MessageBox(hWndMain, szTaskCaption, _T("message"), MB_OK);
			return winhWnd;
		}
	}
	return 0;
}
#endif

// EChE̗
BOOL CALLBACK EnumTaskAllWndProc(HWND hWndEnum, HWND tgthWnd)
{
	int		iResult;
	TCHAR	szTaskCaption[100];

	if (hWndEnum == hWndMain) {
		return TRUE;
	}

	iResult = 0;
	szTaskCaption[0] = '\0';
	iResult = GetWindowText(hWndEnum, szTaskCaption, 99);
	if (!iResult) {
		return TRUE;
	}

	if (NULL != GetWindow(hWndEnum, GW_OWNER)) {
		return TRUE;
	}

	SendDlgItemMessage(tgthWnd, IDC_LIST1, LB_ADDSTRING, 0, (LPARAM)(LPSTR)szTaskCaption);

	lstrcpy(szCaptionname[nTask], szTaskCaption);
	hTask[nTask] = hWndEnum;
	nTask++;
	if (nTask >= iWinlistMax) {
		return FALSE;
	}

	return TRUE;
}

// WM_INITDIALOG
BOOL DoInitWinlistDialog(HWND hDlg)
{
#if 0
	RECT rt1;
	int DlgWidth, DlgHeight;	// sNZPʂł̃_CAO̕ƍ
	int NewPosX, NewPosY;

	if (GetWindowRect(hDlg, &rt1)) {
		DlgWidth	= rt1.right - rt1.left;
		DlgHeight	= rt1.bottom - rt1.top ;
		NewPosX		= (GetSystemMetrics(SM_CXSCREEN) - DlgWidth)  / 2;
		NewPosY		= (GetSystemMetrics(SM_CYSCREEN) - DlgHeight) - 24;
		
		// ʂ傫ꍇ 
		if (NewPosX < 0) NewPosX = 0;
		if (NewPosY < 0) NewPosY = 0;
		SetWindowPos(hDlg, 0, NewPosX, NewPosY,
			0, 0, SWP_NOZORDER | SWP_NOSIZE);
	}
	ShowWindow(hDlg, SW_SHOW);
#else

	SHINITDLGINFO shidi;
	shidi.dwMask = SHIDIM_FLAGS;
	shidi.dwFlags = SHIDIF_DONEBUTTON | SHIDIF_SIPDOWN | SHIDIF_SIZEDLGFULLSCREEN;
	shidi.hDlg = hDlg;
	SHInitDialog(&shidi);
	SetForegroundWindow(hDlg);

	RECT rt1, rt;
	int Width, Height;
	int i;
	int w, h, x, y;
	HWND hWndItem;

	GetClientRect(hDlg, &rt1);
	Width	= (rt1.right - rt1.left) - 4;
	Height	= (rt1.bottom - rt1.top) - 4;

	for (i=1; iDlgItemId[i] != -1; i++) {
		hWndItem = GetDlgItem(hDlg, iDlgItemId[i]);
		GetClientRect(hWndItem, &rt);
		w = rt.right  - rt.left;
		h = rt.bottom - rt.top;
		x = rt1.right - w*i - 2;
		y = rt1.bottom - h - 2;
		SetWindowPos(hWndItem, 0, x, y, w, h, SWP_NOZORDER | SWP_NOSIZE);
	}

	x = 2;
	y = 2;
	SetWindowPos(GetDlgItem(hDlg, IDC_LIST1), 0, x, y, Width, Height - h - 2, SWP_NOZORDER);
#endif

	return TRUE; 
}

// EChE񋓃_CAO
BOOL CALLBACK WinlistDlgFunc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	TCHAR	szTaskName[200];
	TCHAR	szClassName[100];
	int n;

	switch ( message ) {
	case WM_INITDIALOG:
		nTask = 0;
		iWinlistMax = WINLIST_MAX;
		DoInitWinlistDialog(hDlg);
		SendDlgItemMessage(hDlg, IDC_LIST1, LB_RESETCONTENT, 0, 0L);
		EnumWindows((WNDENUMPROC)EnumTaskAllWndProc, (long)hDlg);
		return TRUE ;

	case WM_COMMAND:
		switch ( GET_WM_COMMAND_ID(wParam, lParam) ) {
		case IDC_BUTTON_TITLE:
			n = (int)SendDlgItemMessage(hDlg, IDC_LIST1, LB_GETCURSEL, 0, 0L);
			if (n >= 0) {
				DoSetClipboard(hDlg, szCaptionname[n]);
				SendMessage(hWndEdit, WM_PASTE, 0, 0);
			}
			EndDialog( hDlg, TRUE ) ;
			return TRUE ;

		case IDC_BUTTON_CLASS:
			n = (int)SendDlgItemMessage(hDlg, IDC_LIST1, LB_GETCURSEL, 0, 0L);
			if (n >= 0) {
				GetClassName(hTask[n], szClassName, 99);
				DoSetClipboard(hDlg, szClassName);
				SendMessage(hWndEdit, WM_PASTE, 0, 0);
			}
			EndDialog( hDlg, TRUE ) ;
			return TRUE ;

		case IDC_BUTTON_BOTH:
			n = (int)SendDlgItemMessage(hDlg, IDC_LIST1, LB_GETCURSEL, 0, 0L);
			if (n >= 0) {
				GetClassName(hTask[n], szClassName, 99);
				wsprintf(szTaskName, _T("%s,%s"), szCaptionname[n], szClassName);
				DoSetClipboard(hDlg, szTaskName);
				SendMessage(hWndEdit, WM_PASTE, 0, 0);
			}
			EndDialog( hDlg, TRUE ) ;
			return TRUE ;

		case IDCANCEL:
			EndDialog( hDlg, TRUE ) ;
			return TRUE ;
		}
		break ;
	}
	return FALSE ;
}
